<script lang="ts">
/**
 * This component just handles the case where another component than the default node
 * component should display the current node. It allows for more flexibility and for
 * us to be able to create custom components, for keyboard or visualizer for example.
 */
import { NodeWrapper } from '@/lib/gui/wrappers/NodeWrapper'
import DefaultNode from '@/components/nodes/DefaultNode.vue'
import KeyboardNode from '@/components/nodes/KeyboardNode.vue'
import AnalyserNode from '@/components/nodes/AnalyserNode.vue'
import AnalyserWaveNode from '@/components/nodes/AnalyserWaveNode.vue'
import { mapMutations } from 'vuex'

export default {
  name: "ProxyNode",
  props: {
    node: NodeWrapper,
    dragAtStart: {
      type: Boolean,
      default: false
    },
    index: Number,
  },
  components: {
    DefaultNode,
    KeyboardNode,
    AnalyserNode,
    AnalyserWaveNode,
  },
  methods: {
    ...mapMutations(["cancelEdition"]),
    ...mapMutations("dragAndDrop", [
      "triggerDragStart",
      "triggerDragMove",
      "triggerDragEnd"
    ]),
    dragstart($event: any) {
      this.cancelEdition();
      this.triggerDragStart({node: (this as any).node, event: $event})
    }
  },
  mounted() {
    const vm = this as any;
    if (vm.dragAtStart) {
      vm.$nextTick(() => {
        const group = (vm.$refs.mainGroup as any);
        group._konvaNode.startDrag();
      })
    }
  }
}
</script>

<template>
  <v-group
    :id="`node-group-${node.id}`"
    ref="mainGroup"
    :config="node.config"
    :track-by="node.id"
    @mousedown="dragstart"
    @mouseup="triggerDragEnd({node: node, event: $event})"
    @dragstart="$event.cancelBubble=true"
    @dragend="triggerDragEnd({node: node, event: $event})"
    @dragmove="triggerDragMove"
  >
    <component :is="node.component" :node="node" :index="index" />
  </v-group>
</template>
